<?php
error_reporting(E_ALL | E_STRICT);
ini_set("track_errors", "On");

$INC = dirname(__FILE__) . "/../inc";
require_once(dirname(__FILE__) . "/config.php");
require_once($INC . "/init.inc.php");
require_once($INC . "/util.inc.php");
require_once($INC . "/log.inc.php");
require_once($INC . "/token.inc.php");

rg_log_set_file("token.log");

$rg_no_db = TRUE;
require_once("common.php");

$a = array("ua" => "user-agent1", "sid" => "session1");
$token = rg_token_get($db, $a);
if ($token === FALSE) {
	rg_log("Generating a token should not fail (" . rg_token_error() . ")!");
	exit(1);
}
rg_log("Correct token: $token");

$a['token'] = $token;
$r = rg_token_valid($db, $a, FALSE);
if ($r === FALSE) {
	rg_log("Validating a correct token must work (" . rg_token_error() . ")!");
	exit(1);
}


rg_log("Now, test pre-login sessions...");
$rg_token = FALSE; /* we must remove it from memory */
$a = array("ua" => "user-agent1", "sid" => "Xsession2");
$token = rg_token_get($db, $a);
if ($token === FALSE) {
	rg_log("Generating a token should not fail (" . rg_token_error() . ")!");
	exit(1);
}
rg_log("Correct token: $token");
$a['token'] = $token;

$copy = $a;
$copy['token'] = "y" . substr($a['token'], 1);
$r = rg_token_valid($db, $copy, FALSE);
if ($r !== FALSE) {
	rg_log("An altered token must return error!");
	exit(1);
}

$r = rg_token_valid($db, $a, FALSE);
if ($r === FALSE) {
	rg_log("Validating a correct token must work (" . rg_token_error() . ")!");
	exit(1);
}


rg_log("Testing double posting...");
$rg_token = FALSE; /* we must remove it from memory */
$a = array("ua" => "user-agent3",
	"sid" => "session_double");
$token = rg_token_get($db, $a);
if ($token === FALSE) {
	rg_log("Generating a token should not fail (" . rg_token_error() . ")!");
	exit(1);
}
$a['token'] = $token;

$r = rg_token_valid($db, $a, FALSE);
if ($r === FALSE) {
	rg_log("Calling 'valid' first time must work!");
	exit(1);
}
$r = rg_token_valid($db, $a, FALSE);
if ($r !== FALSE) {
	rg_log("Calling 'valid' second time must NOT work!");
	exit(1);
}

rg_log("OK!");
?>
